from src.functions import available_functions
from src.search import min_search


def main() -> None:
    """Program entrypoint."""
    dims = 3
    iters = 100
    neighbors = 10
    stddev = 1

    for func_name, function in available_functions.items():
        print("-" * 80)
        print(func_name)
        for x in min_search(
            function,
            function.definition_interval.random_point(dims),
            iterations=iters,
            neighbors_count=neighbors,
            std_dev=stddev,
        ):
            y = function(x)
            print(f"{x} -> {y}")


if __name__ == "__main__":
    main()
